<?php
// Create Custom Post Type - HOME PAGE OFFER
add_action( 'admin_init', function() {
    // Add options to database if they don't already exist
    add_option("oms_access_tkn", "", "", "yes");
    add_option("oms_apikeys_ck", "", "", "yes");
    add_option("oms_apikeys_cs", "", "", "yes");

	register_setting('omsapi-plugin-settings', 'oms_access_tkn');
	register_setting('omsapi-plugin-settings', 'oms_apikeys_ck');
	register_setting('omsapi-plugin-settings', 'oms_apikeys_cs');
	//unregister_setting()
});

function oms_plugin_page() {
//GET OR CREATE REST API KEYS ---------------------------------------
	$current_user = wp_get_current_user();
	//$user_info = get_user_meta($current_user->ID);
	global $wpdb;
	$key = $wpdb->get_row( $wpdb->prepare("
		SELECT *
		FROM {$wpdb->prefix}woocommerce_api_keys
		WHERE user_id = $current_user->ID AND description= 'OMS_V1'"), ARRAY_A);

	if($key['description'] =='OMS_V1' && $key['consumer_secret'] && $key['consumer_key']){
		if($key['permissions'] == 'read_write'){
				$orgkeys = $key;
				//$omskey = esc_attr(get_option('oms_access_tkn'));
		}else{
			echo '<p>Rest API access permissions are set wrong. Please follow the below instruction -
				Go to <b>WooCommerce</b>-><b>Advanced</b> tab-> click on <b>REST API</b> link and click on Key name in <b>Description</b> row <br>
				-Select  - Permissions = <b>Read/Write</b><br></p>
			';
		}
	}else{

		// Created API keys.
		$consumer_key    = 'ck_' . wc_rand_hash();
		$consumer_secret = 'cs_' . wc_rand_hash();
		$createkey = $wpdb->insert(
			$wpdb->prefix . 'woocommerce_api_keys',
			array(
				'user_id'         => $current_user->ID,
				'description'     => 'OMS_V1',
				'permissions'     => 'read_write',
				'consumer_key'    => wc_api_hash( $consumer_key ),
				'consumer_secret' => $consumer_secret,
				'truncated_key'   => substr( $consumer_key, -7 ),
			),
			array('%d','%s','%s','%s','%s','%s')
		);
		if($createkey){
			$neworgkeys = array('consumer_key'=> $consumer_key,'consumer_secret'=>  $consumer_secret, 'permissions'=>'read_write'); //SAVE THIS IN DATABASE
			$omsaccesskey = substr(str_shuffle('0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'),1,50);
			add_option("oms_access_tkn", $consumer_key, "", "yes");
			add_option("oms_apikeys_ck", $consumer_secret, "", "yes");
			add_option("oms_apikeys_cs", $omsaccesskey, "", "yes");
			update_option( 'oms_apikeys_ck', $consumer_key );
			update_option( 'oms_apikeys_cs', $consumer_secret );
			update_option( 'oms_access_tkn', $omsaccesskey );
		}else{
			echo '<p>Rest API keys are not exist. Please follow the below instruction -
			Go to <b>WooCommerce</b>-><b>Advanced</b> tab-> click on <b>REST API</b> link and click on <b>Add Key</b> button<br>
			- Description = <b>OMS</b> (Keep this exact name in caps)<br>
			- User = <b>select user</b><br>
			- Permissions = <b>Read/Write</b><br></p>';
		}

	}
	//echo esc_attr(get_option('consumer_secret'));
	print_r($orgkeys['description']);
		//echo '<pre>';
		//print_r($key);
		//echo '</pre>';
?>
<style>body {background: #f1f1f1 !important;}</style>
<div class="wrap">
	<!--center><h1><img src="<?php echo get_option('header_logo'); ?>"></h1></center-->
<div class="wbody">
	<div class="row">
		<div class="col-md-6">
		<a href="https://www.ordermanagersystem.com/" target="_blank"><img src="https://www.ordermanagersystem.com/assets/img/omslogo.png"></a><br>
		</div>
		<div class="col-md-6" style="text-align: right;">
		<p>Visit Order Manager System Website<br></p>
		<p><a class="header_logo_upload"  href="https://www.ordermanagersystem.com/" target="_blank">https://www.ordermanagersystem.com/</a></p><br>
		<p><a class="header_logo_upload"  href="http://support.ordermanagersystem.com/" target="_blank">Help / Customer Service</a></p>
		</div>
	</div>
        <table style="width: 100%;" class="table table-striped">
            <tr>
                <td valign="top" colspan="2">
				<?php
					if(esc_attr(get_option('oms_access_tkn'))){ $oms_access_tkn = esc_attr(get_option('oms_access_tkn')); }else{ $oms_access_tkn = $omsaccesskey; }
					if($orgkeys['consumer_key']){ $consumerkey = $orgkeys['consumer_key']; }else{ $consumerkey = $consumer_key; }
					if($orgkeys['consumer_secret']){ $consumersecret = $orgkeys['consumer_secret']; }else{ $consumersecret = $consumer_secret; }
				?>
                	<div class="row">
					<div class="headertitle">API Access Details</div>
					<div class="col-md-12" style="text-align: center;background: #dbd7d7; padding: 35px;">
					<p>Please make this changes in <b>Permalink Settings</b></p>
					Go to <b>Settings</b> -> Click on <b>Permalink</b> -> Select in "Common Settings" <b>Post name</b> Or <b>Custom Structure</b> and Click on <b>Save Changes</b> Button.
					</div>
					<div class="col-md-12" style="text-align: center;background: #ffa5a5; padding: 5px;"><b>Confidential Information - Do Not Change / Distribute / Share With Anyone</b></div>
					<div class="col-md-12"><br></div>
                	<div class="col-md-12"><label>OMS Access Token</label><input type="text" name="oms_access_tkn" class="form-control" value="<?php echo $oms_access_tkn; ?>" readonly/></div>
                	<div class="col-md-6"><label>RestAPI Consumer Key</label><input type="text" name="oms_apikeys_ck" class="form-control" value="<?php echo $consumerkey; ?>" readonly/></div>
                	<div class="col-md-6"><label>RestAPI Consumer Secret</label><input type="text" name="oms_apikeys_cs" class="form-control" value="<?php echo $consumersecret; ?>" readonly/></div>
                	</div>
                </td>
            </tr>
            <tr>
                <td>
				<div class="row">
					<div class="col-md-12" style="text-align: center;background: #dbd7d7; padding: 35px;">
					<b>PLUGIN INFORMATION</b><hr> This OMS plugin access Order(s) and Product(s) related information. Also other funcitons like updating detail on website, like - order status and tracking details updates and product price and quantity updates. OMS plugin is small application which creates the secure link between <b>OMS</b> (<a href="https://www.ordermanagersystem.com/" target="_blank">OrderManagerSystem.com</a>) and your website to exchange data. API (Application Programming Interface) information - <i>do not share above API information with anyone</i>.
					<hr>
					</div>
				<div class="col-md-12"><br></div>
					<div class="col-md-6"><img src="https://www.ordermanagersystem.com/assets/img/home-map.png"></div>
					<div class="col-md-6" style="text-align: center;background: #e9e8e8; padding: 35px;">
					<b>ORDER MANAGEMENT SYSTEM</b><hr> <b>OMS</b> (<a href="https://www.ordermanagersystem.com/" target="_blank">Order Manager System.com</a>) - Make easy to track and manage all marketplaces orders from one place. We have designed this web application for small or big size of business. We offer very small price for our service. All money goes into server maintenance and development to improve the service and make more easy order management. <br><img src="https://www.ordermanagersystem.com/assets/front1/images/Marketplaces-logo-small.png">
					</div>
				<div class="col-md-12"><br></div>
					<div class="col-md-12" style="text-align: center;background: #d6fffb; padding: 35px;">
					<b>Revoke RestAPI KEYS</b><br> <b>RestAPI Consumer Key</b> and <b>RestAPI Consumer Secret</b> is registered in <b>WooCommerce</b>-><b>Advanced</b> tab-><b>REST API</b>.<br>
					<i><b>Warning:</b> Once you Revoke RestAPI KEYS, it will disconnect from OMS website.</i>
					</div>
				</div>

				</td>
            </tr>
        </table>
</div><div class="col-md-12" style="text-align: center;">Plugin created by <a href="https://www.ordermanagersystem.com/" target="_blank">Order Manager System</a></div>
</div>
<!--Admin page CSS-->
<link rel="stylesheet" type="text/css" href="<?php echo '/wp-content/plugins/order-manager-system/assets/css/admin-page.css';?>" />
<link rel="stylesheet" type="text/css" href="<?php echo '/wp-content/plugins/order-manager-system/assets/css/bootstrap.min.css';?>" />

<?php
	//print_r(wp_load_alloptions());

//-----------------------------TESTING---------------------------------------------------
	//global $wpdb;
	//global $woocommerce; $order;
	$args = array(
		'limit' => 25, //Limit 25 for all use -1
		'order' => 'DASC', //NEW to OLD
	);
	$orders = wc_get_orders($args);
	//echo count($orders);
	$ordersarray = [];
	foreach($orders as $ordid){
			$ordersarray[$ordid->id] = $ordid->data;
			$order = wc_get_order($ordid->id);
			foreach( $order->get_items() as $orderitem ){
				$variations[$ordid->id][] = $orderitem->get_data();
			}
			foreach($variations[$ordid->id] as $ks=>$vardata ){
				$ordersarray[$ordid->id]['variations'][$ks] = $vardata;
				$product = wc_get_product($vardata['product_id']);
				$ordersarray[$ordid->id]['variations'][$ks]['title'] = $product->get_title();
				$ordersarray[$ordid->id]['variations'][$ks]['sku'] = $product->get_sku();
			}
			foreach($order->get_items('shipping')  as $shipm ){
				$ordersarray[$ordid->id]['shipping_method'] = $shipm->get_method_title();
			}
	}

	//$order = wc_get_order( 67 );
	//echo '<pre>';
	//print_r($ordersarray);
	//print_r($ordersarray);
	//echo '</pre>';
//GET ALL ORDERS--------------------------------------------------------------------------------
}