<?php
/**
 * Order-Manager-System
 *
 * @package       OMS
 * @author        OMS Support
 * @version       1.0.0
 *
 * @wordpress-plugin
 * Plugin Name:   Order-Manager-System
 * Plugin URI:    https://www.ordermanagersystem.com/
 * Description:   OMS - Make easy to track and manage all marketplaces orders from one place. We have designed this web application for small or big size of business. We offer very small price for our service. All money goes into server maintenance and development to improve the service and make more easy order management. WE MAKE YOUR IDEAS
 * Version:       1.0.0
 * Author:        OMS Support
 * Author URI:    https://www.ordermanagersystem.com/
 * Text Domain:   order-manager-system
 * Domain Path:   /languages
 */
ini_set('display_errors','Off');
ini_set('error_reporting', E_ALL );
error_reporting(E_ALL & ~E_NOTICE & ~E_WARNING); //CHANGE HERE

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) exit;
// Plugin name
define( 'OMS_NAME',			'Order-Manager-System' );

// Plugin version
define( 'OMS_VERSION',		'1.0.0' );

// Plugin Root File
define( 'OMS_PLUGIN_FILE',	__FILE__ );

// Plugin base
define( 'OMS_PLUGIN_BASE',	plugin_basename( OMS_PLUGIN_FILE ) );

// Plugin Folder Path
define( 'OMS_PLUGIN_DIR',	plugin_dir_path( OMS_PLUGIN_FILE ) );

// Plugin Folder URL
define( 'OMS_PLUGIN_URL',	plugin_dir_url( OMS_PLUGIN_FILE ) );

/**
 * Load the main class for the core functionality
 */
require_once OMS_PLUGIN_DIR . 'core/class-order-manager-system.php';

/**
 * The main function to load the only instance
 * of our master class.
 *
 * @author  OMS Support
 * @since   1.0.0
 * @return  object|Order_Manager_System
 */
function OMS() {
	return Order_Manager_System::instance();
}

OMS();
require( WP_PLUGIN_DIR . '/order-manager-system/inc/oms-home.php' );
add_action('admin_menu', 'Order_Manager_System_plugin_setup_menu');
function Order_Manager_System_plugin_setup_menu(){
    add_menu_page( 'Order Manager System', 'OMS', 'manage_options', 'OMSPlugin', 'oms_plugin_page', 'https://www.ordermanagersystem.com/assets/img/favicon.ico' );
}

add_filter( 'generate_rewrite_rules', function ( $wp_rewrite ){
    $wp_rewrite->rules = array_merge(
        ['oms-plugin/?$' => 'index.php?custom=1'],
        $wp_rewrite->rules
    );
} );
add_filter( 'query_vars', function( $query_vars ){
    $query_vars[] = 'custom';
    return $query_vars;
} );
add_action( 'template_redirect', function(){
    $custom = intval( get_query_var( 'custom' ) );
    if ( $custom ) {
        include WP_PLUGIN_DIR . '/order-manager-system/inc/custom.php';
        //require_once (OMS_PLUGIN_DIR.'inc/custom.php');
        exit();
    }
} );

